"use strict";

exports.__esModule = true;
exports.retryProcessing = exports.getTypeOperation = void 0;

var _rxjs = require("rxjs");

var _model = require("./model");

const getTypeOperation = processingType => {
  switch (processingType) {
    case _model.ProcessingType.CONCAT:
      return _rxjs.concatMap;

    case _model.ProcessingType.EXHAUST:
      return _rxjs.exhaustMap;

    case _model.ProcessingType.FLAT:
      return _rxjs.flatMap;

    case _model.ProcessingType.MERGE:
      return _rxjs.mergeMap;

    case _model.ProcessingType.SWITCH:
      return _rxjs.switchMap;

    default:
      return _rxjs.switchMap;
  }
};

exports.getTypeOperation = getTypeOperation;

const retryProcessing = config => {
  const retryPipeline = (0, _rxjs.retryWhen)(errors => errors.pipe((0, _rxjs.concatMap)((e, i) => (0, _rxjs.iif)(() => i > 10, (0, _rxjs.throwError)(e), (0, _rxjs.of)(e).pipe((0, _rxjs.delay)(500))))));
  return retryPipeline;
};

exports.retryProcessing = retryProcessing;